/* Schedule S Part 4.do (STATA)
	Merge different years of A.M. Best's Schedule S Part 4.
	by Motohiro Yogo. */

#delimit ;
clear all;
set more off;

cap log close;
log using "Schedule S Part 4", replace;

/* 2003 */

u A_M__Best_Company_Name A_M__Best_Company_Number A_M__Best_Group_Name__AMB_Core_ A_M__Best_Group_Number__AMB_Core
	NAIC_Company_Number__AMB_Core_ NAIC_Group_Number__AMB_Core_
	Aggregation_Code__AMB_Core_ Current_Best_s_Rating__AMB_Core_ State_of_Domicile__AMB_Core_
	Reinsurer_Reinsured_Name__Rein_C A_M__Best_Reinsurer_Company_Numb A_M__Best_Reinsurer_Group_Name_ A_M__Best_Reinsurer_Group_Number
	NAIC_Company_Number__Rein_Core_ NAIC_Group_Number__Rein_Core_
	Aggregation_Code__Rein_Core_ Current_Best_s_Rating__Rein_Core Domicile_Jurisdiction__Rein_Core
	Name_of_Reinsurer Effective_Date
	Reserve_Credit_Taken Paid_and_Unpaid_Losses_Recoverab Other_Debits Total_of_Columns_5__6_and_7
	Letters_of_Credit Trust_Agreements Funds_Deposited_By_and_Withheld_ Other Miscellaneous_Balances__Credit_ Sum_Cols_9__10__11__12__13_Not_I
	Section Line_Number
	using "data\2003\2003 schedule s part 4.dta", clear;

gen int Years = 2002;

rename Current_Best_s_Rating__AMB_Core_ Best_s_Rating___Current__AMB_Cor;
rename Reinsurer_Reinsured_Name__Rein_C AMB_Reinsurer_Company_Name__Rein;
rename Current_Best_s_Rating__Rein_Core Best_s_Rating___Current__Rein_Co;
rename Sum_Cols_9__10__11__12__13_Not_I Sum_of_Columns_9_10_11_12__and_1;

destring Reserve_Credit_Taken Paid_and_Unpaid_Losses_Recoverab Other_Debits Total_of_Columns_5__6_and_7 Sum_of_Columns_9_10_11_12__and_1, replace;
destring Letters_of_Credit Trust_Agreements Funds_Deposited_By_and_Withheld_ Other Miscellaneous_Balances__Credit_, replace;
	
save "data\Schedule S Part 4", replace;

/* 2004 */

u A_M__Best_Company_Name A_M__Best_Company_Number A_M__Best_Group_Name__AMB_Core_ A_M__Best_Group_Number__AMB_Core
	NAIC_Company_Number__AMB_Core_ NAIC_Group_Number__AMB_Core_
	Aggregation_Code__AMB_Core_ Best_s_Rating___Current__AMB_Cor State_Jurisdiction_of_Domicile_
	A_M__Best_Reinsurer_Company_Name A_M__Best_Reinsurer_Company_Numb A_M__Best_Reinsurer_Group_Name_ A_M__Best_Reinsurer_Group_Number
	NAIC_Company_Number__Rein_Core_ NAIC_Group_Number__Rein_Core_
	Aggregation_Code__Rein_Core_ Best_s_Rating___Current__Rein_Co Domicile_of_Jurisdiction__Rein_C
	Name_of_Reinsurer Effective_Date
	Reserve_Credit_Taken Paid_and_Unpaid_Losses_Recoverab Other_Debits Total_of_Columns_5__6_and_7
	Letters_of_Credit Trust_Agreements Funds_Deposited_By_and_Withheld_ Other Miscellaneous_Balances__Credit_ Sum_of_Columns_9_10_11_12__and_1
	Section Line_Number
	using "data\2004\2004 schedule s part 4.dta", clear;

gen int Years = 2003;

rename State_Jurisdiction_of_Domicile_ State_of_Domicile__AMB_Core_;
rename A_M__Best_Reinsurer_Company_Name AMB_Reinsurer_Company_Name__Rein;
rename Domicile_of_Jurisdiction__Rein_C Domicile_Jurisdiction__Rein_Core;

tostring A_M__Best_Group_Number__AMB_Core, replace;
tostring NAIC_Company_Number__AMB_Core_, replace;
tostring NAIC_Group_Number__AMB_Core_, replace;
tostring A_M__Best_Reinsurer_Group_Number, replace;
tostring NAIC_Company_Number__Rein_Core_, replace;
tostring NAIC_Group_Number__Rein_Core_, replace;

append using "data\Schedule S Part 4";

rename Line_Number Line;

save "data\Schedule S Part 4", replace;

/* 2005-2008 */

forval y = 2005/2008 {;
	u A_M__Best_Company_Name A_M__Best_Company_Number A_M__Best_Group_Name__AMB_Core_ A_M__Best_Group_Number__AMB_Core
		NAIC_Company_Number__AMB_Core_ NAIC_Group_Number__AMB_Core_
		Aggregation_Code__AMB_Core_ Best_s_Rating___Current__AMB_Cor State_of_Domicile__AMB_Core_
		A_M__Best_Reinsurer_Company_Name A_M__Best_Reinsurer_Company_Numb A_M__Best_Reinsurer_Group_Name_ A_M__Best_Reinsurer_Group_Number
		NAIC_Company_Number__Rein_Core_ NAIC_Group_Number__Rein_Core_
		Aggregation_Code__Rein_Core_ Best_s_Rating___Current__Rein_Co Domicile_Jurisdiction__Rein_Core
		Name_of_Reinsurer Effective_Date
		Reserve_Credit_Taken Paid_and_Unpaid_Losses_Recoverab Other_Debits Total_of_Columns_5__6_and_7
		Letters_of_Credit Trust_Agreements Funds_Deposited_By_and_Withheld_ Other Miscellaneous_Balances__Credit_ Sum_of_Columns_9_10_11_12__and_1
		Section Line
		using "data\\`y'\\`y' schedule s part 4.dta", clear;

	gen int Years = `y'-1;

	rename A_M__Best_Reinsurer_Company_Name AMB_Reinsurer_Company_Name__Rein;

	append using "data\Schedule S Part 4";
	save "data\Schedule S Part 4", replace;
};

/* 2009 */

u A_M__Best_Company_Name A_M__Best_Company_Number A_M__Best_Group_Name__AMB_Core_ A_M__Best_Group_Number__AMB_Core
	NAIC_Company_Number__AMB_Core_ NAIC_Group_Number__AMB_Core_
	Aggregation_Code__AMB_Core_ Best_s_Financial_Strength_Rating State_of_Domicile__AMB_Core_
    A_M__Best_Reinsurer_Company_Name A_M__Best_Reinsurer_Company_Numb A_M__Best_Reinsurer_Group_Name_ A_M__Best_Reinsurer_Group_Number
	NAIC_Company_Number__Rein_Core_ NAIC_Group_Number__Rein_Core_
	Aggregation_Code__Rein_Core_ Best_s_Financial_Strength_Ratin1 Domicile_Jurisdiction__Rein_Core
	Name_of_Reinsurer Effective_Date
	Reserve_Credit_Taken Paid_and_Unpaid_Losses_Recoverab Other_Debits Total_of_Columns_5__6_and_7
	Letters_of_Credit Trust_Agreements Funds_Deposited_By_and_Withheld_ Other Miscellaneous_Balances__Credit_ Sum_of_Columns_9_10_11_12__and_1
	Section Line
	using "data\2009\2009 schedule s part 4.dta", clear;

gen int Years = 2008;

rename Best_s_Financial_Strength_Rating Best_s_Rating___Current__AMB_Cor;
rename A_M__Best_Reinsurer_Company_Name AMB_Reinsurer_Company_Name__Rein;
rename Best_s_Financial_Strength_Ratin1 Best_s_Rating___Current__Rein_Co;

append using "data\Schedule S Part 4";

rename A_M__Best_Company_Name AMB_Company_Name;
rename A_M__Best_Company_Number AMB_Number;
rename A_M__Best_Group_Name__AMB_Core_ AMB_Financial_Group_Name__AMB_Co;
rename A_M__Best_Group_Number__AMB_Core AMB_Financial_Group_Number__AMB_;
rename A_M__Best_Reinsurer_Company_Numb AMB_Reinsurer_Company_Number__Re;
rename A_M__Best_Reinsurer_Group_Name_ AMB_Reinsurer_Financial_Group_Na;
rename A_M__Best_Reinsurer_Group_Number AMB_Reinsurer_Financial_Group_Nu;

save "data\Schedule S Part 4", replace;

/* 2010 */

u AMB_Company_Name AMB_Number AMB_Financial_Group_Name__AMB_Co AMB_Financial_Group_Number__AMB_
	NAIC_Company_Number__AMB_Core_ NAIC_Group_Number__AMB_Core_
	Aggregation_Code__AMB_Core_ Best_s_Financial_Strength_Rating State_of_Domicile__AMB_Core_
	AMB_Reinsurer_Company_Name__Rein AMB_Reinsurer_Company_Number__Re AMB_Reinsurer_Financial_Group_Na AMB_Reinsurer_Financial_Group_Nu
	NAIC_Company_Number__Rein_Core_ NAIC_Group_Number__Rein_Core_
	Aggregation_Code__Rein_Core_ Best_s_Financial_Strength_Ratin4 Domicile_Jurisdiction__Rein_Core
	Name_of_Reinsurer Effective_Date
	Reserve_Credit_Taken Paid_and_Unpaid_Losses_Recoverab Other_Debits Total_of_Columns_5__6_and_7
	Letters_of_Credit Trust_Agreements Funds_Deposited_By_and_Withheld_ Other Miscellaneous_Balances__Credit_ Sum_of_Columns_9_10_11_12__and_1
	Section Line
	using "data\2010\2010 schedule s part 4.dta", clear;

gen int Years = 2009;

rename Best_s_Financial_Strength_Rating Best_s_Rating___Current__AMB_Cor;
rename Best_s_Financial_Strength_Ratin4 Best_s_Rating___Current__Rein_Co;

append using "data\Schedule S Part 4";
save "data\Schedule S Part 4", replace;

/* 2011 */

u AMB_Company_Name AMB_Number AMB_Financial_Group_Name__AMB_Co AMB_Financial_Group_Number__AMB_
	NAIC_Company_Number__AMB_Core_ NAIC_Group_Number__AMB_Core_
	Aggregation_Code__AMB_Core_ Best_s_Financial_Strength_Rating State_of_Domicile__AMB_Core_
	AMB_Reinsurer_Company_Name__Rein AMB_Reinsurer_Company_Number__Re AMB_Reinsurer_Financial_Group_Na AMB_Reinsurer_Financial_Group_Nu
	NAIC_Company_Number__Rein_Core_ NAIC_Group_Number__Rein_Core_
	Aggregation_Code__Rein_Core_ Best_s_Financial_Strength_Ratin4 Domicile_Jurisdiction__Rein_Core
	Name_of_Reinsurer Effective_Date
	Reserve_Credit_Taken Paid_and_Unpaid_Losses_Recoverab Other_Debits Total_of_Columns_5__6_and_7
	Letters_of_Credit Trust_Agreements Funds_Deposited_By_and_Withheld_ Other Miscellaneous_Balances__Credit_ Sum_of_Columns_9_10_11_12__and_1
	Section Line
	using "data\2011\2011 schedule s part 4.dta", clear;

gen int Years = 2010;

rename Best_s_Financial_Strength_Rating Best_s_Rating___Current__AMB_Cor;
rename Best_s_Financial_Strength_Ratin4 Best_s_Rating___Current__Rein_Co;

append using "data\Schedule S Part 4";

rename Sum_of_Columns_9_10_11_12__and_1 Sum_of_Columns_9_13_14_15_and_16;

save "data\Schedule S Part 4", replace;

/* 2012-2013 */

forval y = 2012/2013 {;
	u AMB_Company_Name AMB_Number AMB_Financial_Group_Name__AMB_Co AMB_Financial_Group_Number__AMB_
		NAIC_Company_Number__AMB_Core_ NAIC_Group_Number__AMB_Core_
		Aggregation_Code__AMB_Core_ Best_s_Financial_Strength_Rating State_of_Domicile__AMB_Core_
		AMB_Reinsurer_Company_Name__Rein AMB_Reinsurer_Company_Number__Re AMB_Reinsurer_Financial_Group_Na AMB_Reinsurer_Financial_Group_Nu
		NAIC_Company_Number__Rein_Core_ NAIC_Group_Number__Rein_Core_
		Aggregation_Code__Rein_Core_ Best_s_Financial_Strength_Ratin5 Domicile_Jurisdiction__Rein_Core
		Name_of_Reinsurer Effective_Date
		Reserve_Credit_Taken Paid_and_Unpaid_Losses_Recoverab Other_Debits Total_of_Columns_5__6_and_7
		Letters_of_Credit Trust_Agreements Funds_Deposited_By_and_Withheld_ Other Miscellaneous_Balances__Credit_ Sum_of_Columns_9_13_14_15_and_16
		Section Line
		using "data\\`y'\\`y' schedule s part 4.dta", clear;

	gen int Years = `y'-1;

	rename Best_s_Financial_Strength_Rating Best_s_Rating___Current__AMB_Cor;
	rename Best_s_Financial_Strength_Ratin5 Best_s_Rating___Current__Rein_Co;

	append using "data\Schedule S Part 4";
	save "data\Schedule S Part 4", replace;
};

/* Fix variables */

replace AMB_Reinsurer_Company_Number = "" if AMB_Reinsurer_Company_Number=="**NA*";

destring AMB_Number, replace;
destring AMB_Financial_Group_Number__AMB_, replace;
destring NAIC_Company_Number__AMB_Core_, replace;

destring AMB_Reinsurer_Company_Number__Re, replace;
destring AMB_Reinsurer_Financial_Group_Nu, replace;
destring NAIC_Company_Number__Rein_Core_, replace;

destring Section, replace;
destring Line, replace;

recode NAIC_Company_Number__AMB_Core_ (0=.);
recode NAIC_Company_Number__Rein_Core_ (0=.);

replace Aggregation_Code__AMB_Core_ = "A" if Aggregation_Code__AMB_Core_=="1";
replace Aggregation_Code__AMB_Core_ = "U" if Aggregation_Code__AMB_Core_=="2";

drop if Aggregation_Code__AMB_Core_=="G" | Aggregation_Code__AMB_Core_=="";

replace Aggregation_Code__Rein_Core_ = "A" if Aggregation_Code__Rein_Core_=="1";
replace Aggregation_Code__Rein_Core_ = "U" if Aggregation_Code__Rein_Core_=="2";

gen int date = date(Effective_Date,"MDY");
drop Effective_Date;
rename date Effective_Date;

format %td Effective_Date;

replace Reserve_Credit_Taken = Reserve_Credit_Taken/1000000000;
replace Paid_and_Unpaid_Losses_Recoverab = Paid_and_Unpaid_Losses_Recoverab/1000000000; 
replace Other_Debits = Other_Debits/1000000000;
replace Total_of_Columns_5__6_and_7 = Total_of_Columns_5__6_and_7/1000000000;
replace Letters_of_Credit = Letters_of_Credit/1000000000;
replace Trust_Agreements = Trust_Agreements/1000000000;
replace Funds_Deposited_By_and_Withheld_ = Funds_Deposited_By_and_Withheld_/1000000000;
replace Other = Other/1000000000;
replace Miscellaneous_Balances__Credit_ = Miscellaneous_Balances__Credit_/1000000000;
replace Sum_of_Columns_9_13_14_15_and_16 = Sum_of_Columns_9_13_14_15_and_16/1000000000;

/* Create variables */

drop if Line==99999;

gen byte affiliated = 1 if Years<=2010 & 
	inlist(Section,1,4,8);
replace affiliated = 0 if Years<=2010 & 
	inlist(Section,2,5,9);
replace affiliated = 1 if Years>=2011 & Years<=2012 & 
	inlist(Section,1,2,8,9,16,17);
replace affiliated = 0 if Years>=2011 & Years<=2012 & 
	inlist(Section,4,5,11,12,19,20);
replace affiliated = 1 if Years>=2013 & 
	inlist(Section,1,2,4,5,12,13,15,16,24,25,27,28);
replace affiliated = 0 if Years>=2013 & 
	inlist(Section,8,9,19,20,31,32);

gen byte genaccount = 1 if Years<=2010 & 
	inlist(Section,1,2,4,5);
replace genaccount = 0 if Years<=2010 & 
	inlist(Section,8,9);
replace genaccount = 1 if Years>=2011 & Years<=2012 & 
	inlist(Section,1,2,4,5,8,9,11,12);
replace genaccount = 0 if Years>=2011 & Years<=2012 & 
	inlist(Section,16,17,19,20);
replace genaccount = 1 if Years>=2013 & 
	inlist(Section,1,2,4,5,8,9,12,13,15,16,19,20);
replace genaccount = 0 if Years>=2013 & 
	inlist(Section,24,25,27,28,31,32);

gen byte part31 = 1 if Years<=2010 & 
	inlist(Section,1,2);
replace part31 = 0 if Years<=2010 & 
	inlist(Section,4,5,8,9);
replace part31 = 1 if Years>=2011 & Years<=2012 & 
	inlist(Section,1,2,4,5);
replace part31 = 0 if Years>=2011 & Years<=2012 & 
	inlist(Section,8,9,11,12,16,17,19,20);
replace part31 = 1 if Years>=2013 & 
	inlist(Section,1,2,4,5,8,9);
replace part31 = 0 if Years>=2013 & 
	inlist(Section,12,13,15,16,19,20,24,25,27,28,31,32);

/* Label variables */

rename Name_of_Reinsurer Name_of_Reinsure;

order Years
	AMB_Company_Name AMB_Number AMB_Financial_Group_Name__AMB_Co AMB_Financial_Group_Number__AMB_
	NAIC_Company_Number__AMB_Core_ NAIC_Group_Number__AMB_Core_
	Aggregation_Code__AMB_Core_ Best_s_Rating___Current__AMB_Cor State_of_Domicile__AMB_Core_
    AMB_Reinsurer_Company_Name__Rein AMB_Reinsurer_Company_Number__Re AMB_Reinsurer_Financial_Group_Na AMB_Reinsurer_Financial_Group_Nu
	NAIC_Company_Number__Rein_Core_ NAIC_Group_Number__Rein_Core_
	Aggregation_Code__Rein_Core_ Best_s_Rating___Current__Rein_Co Domicile_Jurisdiction__Rein_Core
	Name_of_Reinsure Effective_Date
	Reserve_Credit_Taken Paid_and_Unpaid_Losses_Recoverab Other_Debits Total_of_Columns_5__6_and_7
	Letters_of_Credit Trust_Agreements Funds_Deposited_By_and_Withheld_ Other Miscellaneous_Balances__Credit_ Sum_of_Columns_9_13_14_15_and_16
	Section Line;

label var Years								"Year";

label var AMB_Company_Name					"AMB Company Name";
label var AMB_Number						"AMB Company Number";
label var AMB_Financial_Group_Name__AMB_Co	"AMB Financial Group Name";
label var AMB_Financial_Group_Number__AMB_	"AMB Financial Group Number";
label var NAIC_Company_Number__AMB_Core_	"NAIC Company Number";
label var NAIC_Group_Number__AMB_Core_		"NAIC Group Number";

label var Aggregation_Code__AMB_Core_		"Aggregation Code";
label var Best_s_Rating___Current__AMB_Cor	"Best's Rating Current";
label var State_of_Domicile__AMB_Core_		"State of Domicile";

label var AMB_Reinsurer_Company_Name__Rein	"Reinsurer/Reinsured: AMB Company Name";
label var AMB_Reinsurer_Company_Number__Re	"Reinsurer/Reinsured: AMB Company Number";
label var AMB_Reinsurer_Financial_Group_Na	"Reinsurer/Reinsured: AMB Financial Group Name";
label var AMB_Reinsurer_Financial_Group_Nu	"Reinsurer/Reinsured: AMB Financial Group Number";
label var NAIC_Company_Number__Rein_Core_	"Reinsurer/Reinsured: NAIC Company Number";
label var NAIC_Group_Number__Rein_Core_		"Reinsurer/Reinsured: NAIC Group Number";

label var Aggregation_Code__Rein_Core_		"Reinsurer/Reinsured: Aggregation Code";
label var Best_s_Rating___Current__Rein_Co	"Reinsurer/Reinsured: Best's Rating Current";
label var Domicile_Jurisdiction__Rein_Core	"Reinsurer/Reinsured: Domicile Jurisdiction";

label var Name_of_Reinsure					"Name of Reinsurer/Reinsured";
label var Effective_Date					"Effective Date";

label var Reserve_Credit_Taken				"Reserve Credit Taken";
label var Paid_and_Unpaid_Losses_Recoverab	"Paid and Unpaid Losses Recoverable (Debit)";
label var Other_Debits						"Other Debits";
label var Total_of_Columns_5__6_and_7		"Total of Columns 5, 6, and 7";

label var Letters_of_Credit					"Letters of Credit";
label var Trust_Agreements					"Trust Agreements";
label var Funds_Deposited_By_and_Withheld_	"Funds Deposited By and Withheld from Reinsurers";
label var Other "Other";
label var Miscellaneous_Balances__Credit_	"Miscellaneous Balances (Credit)";
label var Sum_of_Columns_9_13_14_15_and_16	"Sum of Columns 9, 13, 14, 15 and 16 But Not in Excess of Col 8";

label var Section							"Section";
label var Line								"Line";

label var affiliated						"1 = Affiliated, 0 = Unaffiliated";
label var genaccount						"1 = General Account, 0 = Separate Account";
label var part31							"1 = Life and Annuity, 0 = Accident and Health";

/* Save data */

compress;

save "data\Schedule S Part 4", replace;

log close;
